import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Soldado here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Soldado extends AnimatedActor
{    
    int shootdelay=0;
    int mindelay=5;
    int direccion =0;
    int ataque = 0;
    int municiones = 50;
    int imagen=0;
    int tiempoMun=0;
    int numeroTanque=0;
    int numeroAvanzaX=0;
    int numeroAvionsito=0;
    int hel = 0;
    int cuentaObjetos = 0;
    
    
    public Soldado()
    {
       super("SD", ".png", 3);
         
    }
     
    public void act() 
    { 
        checaCaida();
        checaTecla();
        checaChoque();
        checaMunicion();
        ponMunicion();
        if( getX() < 242 )
            ((Zona)getWorld()).reCambiaSalenObjetos();
    }  
    
    private void checaTecla()
    {   
        int i;
        shootdelay++;
        
        if(municiones>0)
        {
        if(Greenfoot.isKeyDown("a"))
          switch(direccion)
        {
            case 1: disparaDer();
                    municiones-=1;
                    ((Zona)getWorld()).menosMuniciones();
                    break;
            
            case 2: disparaIzq();
                    municiones-=1;
                    ((Zona)getWorld()).menosMuniciones();
                    break;
            
            case 3: disparaArr();
                    municiones-=1;
                    ((Zona)getWorld()).menosMuniciones();
                    break;
        }
        }        
        
        
       
        if ( Greenfoot.isKeyDown("right") )
            {     
                direccion=1;
                setImage("SD0.png");
                if(municiones>0)
                 { 
                     if( Greenfoot.isKeyDown("a"))
                     disparaDer();
                 }
                
                 if(this.getX()<=248)
                 {
                  mueveDerecha();
                 }
                             
                if( getX()>=249 && Greenfoot.isKeyDown("right") )
                {
                    numeroAvanzaX++;
                    //Greenfoot.setSimulationSpeed(80);
                    ((Zona)getWorld()).cambiaImagen();
                    ((Zona)getWorld()).cambiaSalenObjetos();
                    cuentaObjetos++;
                     
                }
                
                if( getX()<249 )
                    ((Zona)getWorld()).reCambiaSalenObjetos();
                
                Greenfoot.setSimulationSpeed(40);
                super.actDer();
                               
                if( Greenfoot.isKeyDown("s") )
                {
                    if(enTierra())
                        super.salta();
                }
            }
            
        else if( Greenfoot.isKeyDown("left") )
            {   
                direccion = 2;
                cambiaMono(); 
                if(municiones>0)
                  {
                      if( Greenfoot.isKeyDown("a"))
                        disparaIzq();
                  }
                
                   mueveIzquierda();
                   if( getX()<249 )
                   ((Zona)getWorld()).reCambiaSalenObjetos();
                
                if( Greenfoot.isKeyDown("s") )
                {
                if(enTierra())
                super.salta();
                }
                                        
            }
        
        else if( Greenfoot.isKeyDown("up") )
            {
                direccion = 3;
                setImage("SA.png");
                if(municiones>0)
                {if (Greenfoot.isKeyDown("a"))
                 
                        disparaArr();
                                            }
            }
        
        else if( Greenfoot.isKeyDown("s") )
                {
                if(enTierra())
                super.salta();
                }
                
       
     
       ataque++;
       hel++;
       tiempoMun++;
       numeroAvionsito++;
               
       
       if( ataque==((Zona)getWorld()).saleEnemigo() && numeroAvanzaX <=219)
       { 
          getWorld().addObject(new Enemigo(), 794, 427);        
          ataque=0;
       }
       
       if(hel == ((Zona)getWorld()).saleHeli())
       {
           getWorld().addObject(new Helicoptero(), 794, 152);
           hel=0;
       }
       
       
       if(numeroAvanzaX == 220)
       {
           Greenfoot.playSound("Intro.wav");
            getWorld().addObject(new Tanque(), 794, 420); 
            numeroAvanzaX = 0;
       }
       
       if(numeroAvionsito == 200)
       {
            getWorld().addObject(new Avion(), 794, 53);
            numeroAvionsito=0;
       }
       
       if( cuentaObjetos == 70 )
       {
            getWorld().addObject( new Nube(), 794, 75 );
            cuentaObjetos = 0;
       }
             
     }
    
    
    public void disparaDer()
    {
    if(shootdelay >= mindelay)
    {
     
     int rot = getRotation();   
     int xOffset = (int)(120 *Math.cos(Math.toRadians(rot)));
     int yOffset = (int)(120 *Math.sin(Math.toRadians(rot)));
     Bala b = new Bala(getRotation());
     Greenfoot.playSound("disparo.wav");
     getWorld().addObject(b, getX()+50, getY()+yOffset);
     shootdelay = 0;
     
    }
    }
    
    
    public void disparaIzq()
    {
    if(shootdelay >= mindelay)
    {//written by JL235//
     
     int rot = getRotation();   
     int xOffset = (int)(120 *Math.cos(Math.toRadians(rot)));
     int yOffset = (int)(120 *Math.sin(Math.toRadians(rot)));
     BalaI b = new BalaI(getRotation());
     Greenfoot.playSound("disparo.wav");
     getWorld().addObject(b, getX()-50, getY()+yOffset);
     shootdelay = 0;
 
     }
    }
    
    
    public void disparaArr()
    {
    if(shootdelay >= mindelay)
    {//written by JL235//
     
     int rot = getRotation();   
     int xOffset = (int)(120 *Math.cos(Math.toRadians(rot)));
     int yOffset = (int)(120 *Math.sin(Math.toRadians(rot)));
     BalaA b = new BalaA(getRotation());
     Greenfoot.playSound("disparo.wav");
     getWorld().addObject(b, getX(), getY()+yOffset-40);
     shootdelay = 0;
    }
    }
    
    
     public void checaChoque()
     {
        Actor enemigo = getOneIntersectingObject(Enemigo.class);
        if(enemigo!=null)
        {   ((Zona)getWorld()).restaVidas();
            this.setLocation(100,410);
         }
        
        Actor bala = getOneIntersectingObject(Misil.class);
        if(bala!=null)
        {
          ((Zona)getWorld()).restaVidas();
          this.setLocation(100,410);
          getWorld().removeObject(bala);
        }
        
        Actor balaE = getOneIntersectingObject(BalaEne.class);
        if(balaE!=null)
        {   ((Zona)getWorld()).restaVidas();
            this.setLocation(100,410);
            getWorld().removeObject(balaE);
         }
         
       Actor canon = getOneIntersectingObject(Canon.class);
       if(canon!=null) 
       {   
            ((Zona)getWorld()).restaVidas();
            this.setLocation(100,410);
            getWorld().removeObject(canon);
       }
       
       Actor avion = getOneIntersectingObject(Avion.class);
       if(avion!=null) 
       {   
            ((Zona)getWorld()).restaVidas();
            this.setLocation(100,410);
       }
       
       Actor bot = getOneIntersectingObject(Botiquin.class);
        if(bot!=null)
        {
            ((Zona)getWorld()).sumaVidas();
            getWorld().removeObject(bot);
        }
     }      
      
     
     public void checaMunicion()
      {
        Actor mun = getOneIntersectingObject(Municiones.class);
        if(mun!=null)
          {   
              getWorld().removeObject(mun);
              municiones+=20;
             ((Zona)getWorld()).masMunicion();
              
          }
      }
     
      
      
      /**
       * En esta funcin se tomo referencia del proyecto de mis compaeros de Hopper
       * Para dependieno de la direccion del jugador, cambie la imagen
       * Ya que no tenia idea de como hacer otra imagen animada e intercambiarla dependiendo de la direccion
       */
      public void cambiaMono()
      {
        switch(direccion)
        {
            case 2: 
                    switch(imagen)
                    {
                        case 0: setImage("SI0.png");
                                break;
                        case 1: setImage("SI1.png");
                                break;
                        case 2: setImage("SI2.png");
                                break;
                    }
                    break;
        }
        imagen = (imagen +1)%3;
    } 
    
    
    public void ponMunicion()
    {
       
       int x = Greenfoot.getRandomNumber(250);
               
       if(tiempoMun == 200)
        {
            getWorld().addObject(new Municiones(), x, 420);
            tiempoMun=0;
        }
    }
}     

