import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Zona here.
 * 
 * @author LBB Marco Jones 
 * @version 4/11/2008
 */
public class Zona extends World
{
    private Puntaje puntos;
    private Municion municiones;
    private Vidas vidas;
    int img = 0;
    int nivel = 0;
    int damage = 0;
    int megaDamage = 30;
    int tiempoEnemigo = 0;
    int tiempoHeli = 0;
    int timer = 2000;
    int numMalos=0;
    boolean salenObjetos = false;
    /**
     * Constructor for objects of class Zona.
     * 
     */
    public Zona()
    {    
     
        super(794, 500, 1);
        setBackground("fondoJuego.JPG");
        BotonInicio BI = new BotonInicio(this);
        addObject( BI, 400, 370 );         
    }
    
    public void inicioJuego()
    {
        cambiaImagen();
        removeObjects( getObjects(BotonInicio.class) );
        removeObjects( getObjects(Avion.class) );
        addObject( new Piedra(), 397, 510);
        addObject( new Soldado(), 50,430);
        addObject(new Enemigo(), 700,431);
        
        addObject(new Municiones(), 273, 294);
        addObject(new Helicoptero(), 794, 152);
        addObject( new Nube(), 794, 75 );
        addObject( new Nube(), 174, 75 );
        addObject( new Nube(), 484, 75 );
        
        addObject(new Avion(), 794, 53);
              
        puntos=new Puntaje();
        addObject(puntos, 330, 40);
        addObject(new Tiempo(), 690, 40);
        
        municiones=new Municion();
        addObject(municiones, 120, 40);
        
        vidas = new Vidas();
        addObject(vidas, 570, 43);
      
        addObject(new Cara(), 455, 30);
        
     }
     
     public boolean mueveObjetos()
     {
        return salenObjetos;   
     }
     
     public void cambiaSalenObjetos()
     {
        salenObjetos = true;   
     }
     
     public void reCambiaSalenObjetos()
     {
        salenObjetos = false;   
     }
     
      
      public void puntos()
        {
           puntos.addPoints();
        }
        
         public void menosMuniciones()
      {
          municiones.restaMunicion();
       }
      
      public void masMunicion()
      {
      municiones.sumaMunicion();
      }
      
      public void restaVidas()
      {
        vidas.restaVida();
      }
      
      public void sumaVidas()
      {
        vidas.sumaVida();  
      }
      
      public void sumaMalo()
      {
        numMalos++;  
      }
      
      public int dimeMalos()
      {
        return numMalos;  
      }
            
    public int dimeDamage()
    {
       return damage;  
    }
    
    public int dimeMegaDamage()
    {
        return megaDamage;
    }
      
    public int saleEnemigo()
    {
       return tiempoEnemigo;
    }
    
    public int saleHeli()
    {
        return tiempoHeli;
    }
    
    public void cambiaNivel()
    {
        nivel++;
    }
    
    public void cambiaImagen()
    {
      switch(nivel)
      {
        case 0:
            damage=10;
            tiempoEnemigo = 60;
            tiempoHeli = 75;
            switch(img)
            {
            case 0: setBackground("D1.JPG");
                    break;
            case 1: setBackground("D2.JPG");
                    break;
            case 2: setBackground("D3.JPG");
                    break;
            case 3: setBackground("D4.JPG");
                    break;
            case 4: setBackground("D5.JPG");
                    break;
            case 5: setBackground("D6.JPG");
                    break;
            case 6: setBackground("D7.JPG");
                    break;
            case 7: setBackground("D8.JPG");
                    break;
            case 8: setBackground("D9.JPG");
                    break;
            case 9: setBackground("D10.JPG");
                    break;
            case 10: setBackground("D11.JPG");
                    break;
            case 11: setBackground("D12.JPG");
                    break;
            case 12: setBackground("D13.JPG");
                    break;
            case 13: setBackground("D14.JPG");
                    break;
            case 14: setBackground("D15.JPG");
                    break;
            case 15: setBackground("D16.JPG");
                    break;
            case 16: setBackground("D17.JPG");
                    break;
            case 17: setBackground("D18.JPG");
                    break;
            case 18: setBackground("D19.JPG");
                    break;
            case 19: setBackground("D20.JPG");
                    break;
        }    
        img = (img + 1)%20;
        break;
    
     case 1: damage = 20;
             tiempoEnemigo = 50;
             tiempoHeli = 65;
            
            switch(img)
            {
            case 0: setBackground("D1.JPG");
                    break;
            case 1: setBackground("D2.JPG");
                    break;
            case 2: setBackground("D3.JPG");
                    break;
            case 3: setBackground("D4.JPG");
                    break;
            case 4: setBackground("D5.JPG");
                    break;
            case 5: setBackground("D6.JPG");
                    break;
            case 6: setBackground("D7.JPG");
                    break;
            case 7: setBackground("D8.JPG");
                    break;
            case 8: setBackground("D9.JPG");
                    break;
            case 9: setBackground("D10.JPG");
                    break;
            case 10: setBackground("D11.JPG");
                    break;
            case 11: setBackground("D12.JPG");
                    break;
            case 12: setBackground("D13.JPG");
                    break;
            case 13: setBackground("D14.JPG");
                    break;
            case 14: setBackground("D15.JPG");
                    break;
            case 15: setBackground("D16.JPG");
                    break;
            case 16: setBackground("D17.JPG");
                    break;
            case 17: setBackground("D18.JPG");
                    break;
            case 18: setBackground("D19.JPG");
                    break;
            case 19: setBackground("D20.JPG");
                    break;
        }    
        img = (img + 1)%20;
        break;
        
     case 2: damage = 30;
             tiempoEnemigo = 35;
             tiempoHeli = 50;
        
            switch(img)
            {
            case 0: setBackground("D1.JPG");
                    break;
            case 1: setBackground("D2.JPG");
                    break;
            case 2: setBackground("D3.JPG");
                    break;
            case 3: setBackground("D4.JPG");
                    break;
            case 4: setBackground("D5.JPG");
                    break;
            case 5: setBackground("D6.JPG");
                    break;
            case 6: setBackground("D7.JPG");
                    break;
            case 7: setBackground("D8.JPG");
                    break;
            case 8: setBackground("D9.JPG");
                    break;
            case 9: setBackground("D10.JPG");
                    break;
            case 10: setBackground("D11.JPG");
                    break;
            case 11: setBackground("D12.JPG");
                    break;
            case 12: setBackground("D13.JPG");
                    break;
            case 13: setBackground("D14.JPG");
                    break;
            case 14: setBackground("D15.JPG");
                    break;
            case 15: setBackground("D16.JPG");
                    break;
            case 16: setBackground("D17.JPG");
                    break;
            case 17: setBackground("D18.JPG");
                    break;
            case 18: setBackground("D19.JPG");
                    break;
            case 19: setBackground("D20.JPG");
                    break;
        }    
        img = (img + 1)%20;
        break;    
      }  
   }
}

